var path = require('path')
var webpack = require('webpack')

var entry=process.env.NODE_ENV=="development"?"./src/main.js":"./index.js";

var fileName=process.env.NODE_ENV=="development"?"jpaas-form-dev.js":"jpaas-form-component.js";

var externals=process.env.NODE_ENV=="development"?[]:[
  "axios",
  "ant-design-vue",
  "ant-design-vue/dist/antd.css",
  "vue",
  "js-base64",
  "vuex",
  "jpaas-common-lib",
  "vue-ls",
  "tinymce",
  "@tinymce/tinymce-vue",
  "vue-qart",
  "vue-router",
  "vue-codemirror",
  "vue-layer",
  "baidutemplate",
  "bpmn-js"
];

function resolve (dir) {
	console.info("-------------------------------");
	console.info(path.join(__dirname, '.', dir));
  return path.join(__dirname, '.', dir)
}


/**/
module.exports = {
  entry: entry,
  output: {
    path: path.resolve(__dirname, './dist'),
    publicPath: '/dist/',
    filename: fileName,
    library: 'jpaas-form-component',
    libraryTarget:'umd',
    umdNamedDefine: true
  },
  //在打包时需要排除的环境包。
  externals: [
	  "@tinymce/tinymce-vue",
    "ant-design-vue",
    "axios",
    "moment",
    "tinymce",
    "vue",
    "vue-codemirror",
    "vue-layer",
    "vue-qart",
    "vue-router",
    "vuex",
    "jpaas-common-lib",
    "vue-ls",
   	"bpmn-js"
  ],
  module: {
    rules: [
      {
        test: /\.css$/,
        use: [
          'vue-style-loader',
          'css-loader'
        ],
      },      {
        test: /\.vue$/,
        loader: 'vue-loader',
        options: {
          loaders: {
          }
          // other vue-loader options go here
        }
      },
      {
        test: /\.js$/,
        loader: 'babel-loader',
        include: [resolve('index.js'),resolve('src'),  resolve('node_modules/webpack-dev-server/client'),
        resolve('node_modules/jpaas-common-lib/src'),
        resolve('node_modules/quill-image-super-solution-module')]
      },
      {
        test: /\.(png|jpg|gif|svg)$/,
        loader: 'url-loader',
        options: {
          name: '[name].[ext]?[hash]'
        }
      },
      {
        test: /\.(ttf|eot|woff|woff2)$/,
        use: {
          loader: "url-loader",
          options: {
            limit: 50000,
            mimetype: "application/font-woff",
            name: "./fonts/[name].[ext]"
          }
        }
      }
    ]
  },
  resolve: {
    alias: {
      'vue$': 'vue/dist/vue.esm.js'
    },
    extensions: ['*', '.js', '.vue', '.json']
  },
  devServer: {
    port: 8080,
    proxy: {
      '/api': {
        //target: 'http://139.186.65.108:9900',
        //target: 'http://129.28.157.247:9900',
        target: 'http://localhost:9900',
        pathRewrite: { '^/api': '' },
        ws: false,
        changeOrigin: true
      }
    }
  },
  performance: {
    hints: false
  },

  devtool: '#eval-source-map'
}

if (process.env.NODE_ENV === 'production') {
  module.exports.devtool = '#source-map'
  // http://vue-loader.vuejs.org/en/workflow/production.html
  module.exports.plugins = (module.exports.plugins || []).concat([
    new webpack.DefinePlugin({
      'process.env': {
        NODE_ENV: '"production"'
      }
    }),
    new webpack.optimize.UglifyJsPlugin({
      sourceMap: false,
      compress: {
        warnings: false
      }
    }),
    new webpack.LoaderOptionsPlugin({
      minimize: true
    })
  ])
}
